import * as React from "react";
import styled from "src/theme/styledComponents";

interface Props {
  className?: string;
  onClick?: () => void;
  name: string;
  color: string;
  width: string;
  height: string;
}

const Wrapper = styled("span")`
  display: flex;
`;

const Icon: React.SFC<Props> = ({
  name,
  className,
  color,
  width,
  height,
  onClick
}) => {
  let content;
  if (name === "left-arrow") {
    content = (
      <svg
        version="1.1"
        xmlns="http://www.w3.org/2000/svg"
        x="0px"
        y="0px"
        viewBox="0 0 477.175 477.175"
        width={width}
        height={height}
      >
        <path
          d="M145.188,238.575l215.5-215.5c5.3-5.3,5.3-13.8,0-19.1s-13.8-5.3-19.1,0l-225.1,225.1c-5.3,5.3-5.3,13.8,0,19.1l225.1,225
    c2.6,2.6,6.1,4,9.5,4s6.9-1.3,9.5-4c5.3-5.3,5.3-13.8,0-19.1L145.188,238.575z"
          fill={color}
        />
      </svg>
    );
  } else if (name === "right-arrow") {
    content = (
      <svg
        version="1.1"
        xmlns="http://www.w3.org/2000/svg"
        viewBox="0 0 129 129"
        enableBackground="new 0 0 129 129"
        width={width}
        height={height}
      >
        <g>
          <path
            fill={color}
            d="m40.4,121.3c-0.8,0.8-1.8,1.2-2.9,1.2s-2.1-0.4-2.9-1.2c-1.6-1.6-1.6-4.2 0-5.8l51-51-51-51c-1.6-1.6-1.6-4.2 0-5.8 1.6-1.6 4.2-1.6 5.8,0l53.9,53.9c1.6,1.6 1.6,4.2 0,5.8l-53.9,53.9z"
          />
        </g>
      </svg>
    );
  } else if (name === "search") {
    content = (
      <svg
        xmlns="http://www.w3.org/2000/svg"
        viewBox="1355 201 28.964 30"
        width={width}
        height={height}
      >
        <path
          fill={color}
          d="M29.507,27.325,22.367,19.9A12.108,12.108,0,1,0,13.1,24.225a11.983,11.983,0,0,0,6.939-2.192l7.194,7.482a1.58,1.58,0,1,0,2.277-2.19ZM13.1,3.16a8.953,8.953,0,1,1-8.953,8.953A8.963,8.963,0,0,1,13.1,3.16Z"
          transform="translate(1354.016 201)"
        />
      </svg>
    );
  } else if (name === "clock") {
    content = (
      <svg
        version="1.1"
        xmlns="http://www.w3.org/2000/svg"
        width={width}
        height={height}
        viewBox="0 0 612 612"
      >
        <path
          fill={color}
          d="M587.572,186.881c-32.266-75.225-87.096-129.934-162.949-162.285C386.711,8.427,346.992,0.168,305.497,0.168
			c-41.488,0-80.914,8.181-118.784,24.428C111.488,56.861,56.415,111.535,24.092,186.881C7.895,224.629,0,264.176,0,305.664
			c0,41.496,7.895,81.371,24.092,119.127c32.323,75.346,87.403,130.348,162.621,162.621c37.877,16.247,77.295,24.42,118.784,24.42
			c41.489,0,81.214-8.259,119.12-24.42c75.853-32.352,130.683-87.403,162.956-162.621C603.819,386.914,612,347.16,612,305.664
			C612,264.176,603.826,224.757,587.572,186.881z M538.724,440.853c-24.021,41.195-56.929,73.876-98.375,98.039
			c-41.195,24.021-86.332,36.135-134.845,36.135c-36.47,0-71.27-7.024-104.4-21.415c-33.129-14.384-61.733-33.294-85.661-57.215
			c-23.928-23.928-42.973-52.811-57.214-85.997c-14.199-33.065-21.08-68.258-21.08-104.735c0-48.52,11.921-93.428,35.807-134.509
			c23.971-41.231,56.886-73.947,98.039-98.04c41.146-24.092,85.99-36.142,134.502-36.142c48.52,0,93.649,12.121,134.845,36.142
			c41.446,24.164,74.283,56.879,98.375,98.039c24.092,41.153,36.135,85.99,36.135,134.509
			C574.852,354.185,562.888,399.399,538.724,440.853z"
        />
        <path
          fill={color}
          d="M324.906,302.988V129.659c0-10.372-9.037-18.738-19.41-18.738c-9.701,0-18.403,8.366-18.403,18.738v176.005
			c0,0.336,0.671,1.678,0.671,2.678c-0.671,6.024,1.007,11.043,5.019,15.062l100.053,100.046c6.695,6.695,19.073,6.695,25.763,0
			c7.694-7.695,7.188-18.86,0-26.099L324.906,302.988z"
        />
      </svg>
    );
  } else if (name === "tag") {
    content = (
      <svg
        version="1.1"
        xmlns="http://www.w3.org/2000/svg"
        viewBox="0 0 129 129"
        width={width}
        height={height}
      >
        <path
          fill={color}
          d="m121.3,66.4l-58.7-58.7c-0.9-0.9-2.2-1.3-3.4-1.2l-44,5c-1.9,0.2-3.5,1.7-3.7,3.7l-5,44c-0.1,1.3 0.3,2.5 1.2,3.4l58.7,58.7c0.8,0.8 1.9,1.2 3,1.2 1.1,0 2.1-0.4 3-1.2l49-49c0.8-0.8 1.2-1.8 1.2-3-0.1-1-0.5-2.1-1.3-2.9zm-106.2-8.3l4.4-38.6 38.6-4.4 39.9,39.9-43,43-39.9-39.9zm54.3,54.3l-8.4-8.4 43-43 8.4,8.4-43,43z"
        />
        <path
          fill={color}
          d="m54.7,32.2c-3-3-7-4.7-11.3-4.7s-8.2,1.7-11.3,4.7c-6.2,6.2-6.2,16.3 0,22.5 3,3 7,4.7 11.3,4.7s8.2-1.7 11.3-4.7c3-3 4.7-7 4.7-11.3-7.10543e-15-4.2-1.7-8.2-4.7-11.2zm-5.9,16.6c-2.8,2.8-7.8,2.8-10.7,0-2.9-2.9-2.9-7.7 0-10.7 1.4-1.4 3.3-2.2 5.3-2.2s3.9,0.8 5.3,2.2c1.4,1.4 2.2,3.3 2.2,5.3 0.1,2.1-0.7,3.9-2.1,5.4z"
        />
      </svg>
    );
  } else if (name === "hamburger") {
    content = (
      <svg
        version="1.1"
        xmlns="http://www.w3.org/2000/svg"
        width={width}
        height={height}
        viewBox="0 0 612 612"
      >
        <path
          fill={color}
          d="M0,95.625v38.25h612v-38.25H0z M0,325.125h612v-38.25H0V325.125z M0,516.375h612v-38.25H0V516.375z"
        />
      </svg>
    );
  }

  return (
    <Wrapper className={className} onClick={onClick}>
      {content}
    </Wrapper>
  );
};

export default Icon;
